Use Windows.pkg
Use DFClient.pkg
Use cszJSONParser.pkg
Use dfTabDlg.pkg
Use cTextEdit.pkg

Deferred_View Activate_oJSONDemo for ;
Object oJSONDemo is a dbView
    Object oParser is a cszJSONParser
    End_Object

    Set Border_Style to Border_Thick
    Set Size to 247 543
    Set Location to 10 10
    Set Label to "JSON Demo"

    Object oDbTabDialog1 is a dbTabDialog
        Set Size to 238 536
        Set Location to 3 3
    
        Set Rotate_Mode to RM_Rotate

        Object oDbTabPage1 is a dbTabPage
            Set Label to "Deserialize"
            
            Object oJSONText is a cTextEdit
                Set Size to 142 237
                Set Location to 55 8
                Set Label to "JSON Text"
            End_Object

            Object oButton1 is a Button
                Set Size to 14 76
                Set Location to 203 9
                Set Label to "Deserialize / Serialize"
            
                // fires when the button is clicked
                Procedure OnClick
                    String sJSON
                    Get Value of oJSONText to sJSON
                    
                    Integer hoJSON
                    Get DeserializeString of oParser sJSON to hoJSON
                    If (hoJSON=0) Begin
                        Send Info_Box "Deserialization failed"
                        Procedure_Return
                    End
                    Else Begin
                        Send Info_Box "Deserialization successful"                        
                    End

                    Get Serialize of hoJSON to sJSON
                    Set Value of oJSONText1 to sJSON                    
                End_Procedure
            
            End_Object

            Object oJSONText1 is a cTextEdit
                Set Size to 142 237
                Set Location to 55 281
                Set Label to "after Deserialize / Serialize"
            End_Object

            Object oTextBox1 is a TextBox
                Set Size to 10 338
                Set Location to 8 6
                Set Label to "Deserialization converts a string containg a JSON document to an in memory JSON object that can be processed"
            End_Object

            Object oTextBox2 is a TextBox
                Set Size to 10 197
                Set Location to 22 6
                Set Label to "Serialization converts an in memory JSON object to a JSON string"
            End_Object
        End_Object

        Object oDbTabPage2 is a dbTabPage
            Set Label to "Path"

            Object oPathJSONText is a cTextEdit
                Set Size to 65 514
                Set Location to 57 7
                Set Label to "JSON Text"
            End_Object

            Object oTextBox1 is a TextBox
                Set Size to 10 307
                Set Location to 6 6
                Set Label to "JSON Tokens can be accessed by path. For example 'astring' or 'anobject.name' or anobject.anarray[1]"
            End_Object

            Object oButton2 is a Button
                Set Size to 14 85
                Set Location to 142 25
                Set Label to "Get Value At Path"
            
                // fires when the button is clicked
                Procedure OnClick
                    String sJSON

                    // first we need to read the JSON object
                    Get Value of oJSONText to sJSON
                    
                    Integer hoJSON
                    Get DeserializeString of oParser sJSON to hoJSON
                    If (hoJSON=0) Begin
                        Send Info_Box "Deserialization failed"
                        Procedure_Return
                    End
                    
                    String sPath
                    Get Value of oPath to sPath
                    
                    String sValue
                    Get GetValueAtPath of hoJSON sPath to sValue
                    Set Value of oValue to sValue
                End_Procedure
            
            End_Object

            Object oPath is a Form
                Set Size to 13 353
                Set Location to 124 24
                Set Label to "Path:"
                Set Label_Col_Offset to 0
                Set Label_Justification_Mode to JMode_Right
            
                // OnChange is called on every changed character
            //    Procedure OnChange
            //        String sValue
            //    
            //        Get Value to sValue
            //    End_Procedure
            
            End_Object

            Object oValue is a Form
                Set Size to 13 237
                Set Location to 143 141
                Set Label to "Value"
                Set Label_Col_Offset to 0
                Set Label_Justification_Mode to JMode_Right
                Set Enabled_State to False
                
                // OnChange is called on every changed character
            //    Procedure OnChange
            //        String sValue
            //    
            //        Get Value to sValue
            //    End_Procedure
            
            End_Object

            Object oButton2 is a Button
                Set Size to 14 85
                Set Location to 163 25
                Set Label to "Get Token At Path"
            
                // fires when the button is clicked
                Procedure OnClick
                    String sJSON

                    // first we need to read the JSON object
                    Get Value of oJSONText to sJSON
                    
                    Integer hoJSON
                    Get DeserializeString of oParser sJSON to hoJSON
                    If (hoJSON=0) Begin
                        Send Info_Box "Deserialization failed"
                        Procedure_Return
                    End
                    
                    String sPath
                    Get Value of oPath to sPath
                    
                    Integer hoJSONObject
                    Get GetAtPath of hoJSON sPath to hoJSONObject
                    If (hoJSONObject=0) Begin
                        Set Value of oType to "Not Found"
                        Set Value of oChildCount to ""
                        Set Value of oHasValues to ""
                    End
                    Else Begin
                        Set Value of oType to (TokenTypeAsString(hoJSONObject))                     
                        Set Value of oChildCount to (ChildCount(hoJSONObject))
                        Set Value of oHasValues to (If(HasValues(hoJSONObject),"YES","NO"))
                    End
                End_Procedure
            
            End_Object

            Object oType is a Form
                Set Size to 13 86
                Set Location to 164 141
                Set Label to "Type"
                Set Label_Col_Offset to 0
                Set Label_Justification_Mode to JMode_Right
                Set Enabled_State to False
                
                // OnChange is called on every changed character
            //    Procedure OnChange
            //        String sValue
            //    
            //        Get Value to sValue
            //    End_Procedure
            
            End_Object

            Object oHasValues is a Form
                Set Size to 13 31
                Set Location to 164 259
                Set Label to "Type"
                Set Label_Col_Offset to 0
                Set Label_Justification_Mode to JMode_Right
                Set Enabled_State to False
                
                // OnChange is called on every changed character
            //    Procedure OnChange
            //        String sValue
            //    
            //        Get Value to sValue
            //    End_Procedure
            
            End_Object

            Object oChildCount is a Form
                Set Size to 13 31
                Set Location to 164 337
                Set Label to "Child Count:"
                Set Label_Col_Offset to 0
                Set Label_Justification_Mode to JMode_Right
                Set Enabled_State to False
                
                // OnChange is called on every changed character
            //    Procedure OnChange
            //        String sValue
            //    
            //        Get Value to sValue
            //    End_Procedure
            
            End_Object

            Object oTextBox3 is a TextBox
                Set Auto_Size_State to False
                Set Size to 21 414
                Set Location to 20 6
                Set Label to "If the token is known to be a value token you can use the GetValueAtPath method. If it is a non value token such as an object or property you can use the GetTokenAtPath method"
                Set Justification_Mode to JMode_Left
            End_Object
        End_Object

        Object oDbTabPage5 is a dbTabPage
            Set Label to "JPath Select"

            Object oTextBox1 is a TextBox
                Set Size to 10 307
                Set Location to 6 6
                Set Label to "The Select function allows selecting tokens using JPath expressions"
            End_Object
            Object oJPathJSONText is a cTextEdit
                Set Size to 65 514
                Set Location to 31 7
                Set Label to "JSON Text"
            End_Object
            Object oPath is a Form
                Set Size to 13 353
                Set Location to 124 24
                Set Label to "Path:"
                Set Label_Col_Offset to 0
                Set Label_Justification_Mode to JMode_Right
            
                // OnChange is called on every changed character
            //    Procedure OnChange
            //        String sValue
            //    
            //        Get Value to sValue
            //    End_Procedure
            
            End_Object
            Object oButton2 is a Button
                Set Size to 14 85
                Set Location to 142 25
                Set Label to "Select"
            
                // fires when the button is clicked
                Procedure OnClick
                    String sJSON

                    // first we need to read the JSON object
                    Get Value of oJPathJSONText to sJSON
                    
                    Integer hoJSON
                    Get DeserializeString of oParser sJSON to hoJSON
                    If (hoJSON=0) Begin
                        Send Info_Box "Deserialization failed"
                        Procedure_Return
                    End
                    
                    String sPath
                    Get Value of oPath to sPath
                    
                    Integer[] jsonObjs
                    Get SelectTokens of hoJSON sPath to jsonObjs
                    Set Value of oResCount to (SizeOfArray(jsonObjs))
                End_Procedure
            
            End_Object

            Object oResCount is a Form
                Set Size to 13 31
                Set Location to 142 155
                Set Label to "Count:"
                Set Label_Col_Offset to 0
                Set Label_Justification_Mode to JMode_Right
                Set Enabled_State to False
                
                // OnChange is called on every changed character
            //    Procedure OnChange
            //        String sValue
            //    
            //        Get Value to sValue
            //    End_Procedure
            
            End_Object
        End_Object

        Object oDbTabPage3 is a dbTabPage
            Set Label to "Enumerate"

            Object oTextBox1 is a TextBox
                Set Size to 10 307
                Set Location to 6 6
                Set Label to "You can enumerate a JSON document "
            End_Object
            Object oEnumJSONText is a cTextEdit
                Set Size to 142 237
                Set Location to 33 7
                Set Label to "JSON Text"
            End_Object

            Object oButton2 is a Button
                Set Size to 14 85
                Set Location to 186 219
                Set Label to "Enumerate"
            
                Procedure DoEnumChildren Integer iIndent Integer hoParent
                    String sType sName
                    Get TokenTypeAsString of hoParent to sType
                    
                    Integer iType
                    Get TokenType of hoParent to iType
                    
                    String sPath
                    Get TokenPath of hoParent to sPath
                    
                    Boolean bHasValues
                    Get HasValues of hoParent to bHasValues
                    
                    String sVal
                    
                    Case Begin
                        Case (iType=JTokenType_Object)
                            Send AppendTextLn to oResult ((Repeat("  ",iIndent))+"{")                            
                            Case Break
        
                        Case (iType=JTokenType_Property)
                            Get PropertyName of hoParent to sName
                            Send AppendText to oResult ((Repeat("  ",iIndent))+'"'+trim(sName)+'": ')
                            Case Break
                            
                        Case (iType=JTokenType_Array)
                            Send AppendTextLn to oResult ((Repeat("  ",iIndent))+"[")
                            Case Break

                        Case (iType=JTokenType_Boolean)
                        Case (iType=JTokenType_Null)
                        Case (iType=JTokenType_Raw)
                        Case (iType=JTokenType_Bytes)
                        Case (iType=JTokenType_Date)
                        Case (iType=JTokenType_Float)
                        Case (iType=JTokenType_Integer)
                        Case (iType=JTokenType_TimeSpan)
                            Get TokenValue of hoParent to sVal
                            Send AppendText to oResult sVal //((Repeat("  ",iIndent))+sVal)
                            Send AppendTextLn to oResult ","
                            Case Break

                        Case (iType=JTokenType_String)
                        Case (iType=JTokenType_Uri)
                        Case (iType=JTokenType_Comment)
                        Case (iType=JTokenType_Guid)
                            Get TokenValue of hoParent to sVal
                            Send AppendText to oResult ('"'+sVal+'"')  //((Repeat("  ",iIndent))+sVal)
                            Send AppendTextLn to oResult ","
                            Case Break
                    Case End
                    
                    If (bHasValues) Begin
                        Integer iCount
                        Get ChildCount of hoParent to iCount
                        Integer iIndex
                        For iIndex from 0 to (icount-1)                
                            Handle hoChild
                            Get ChildTokenByIndex of hoParent iIndex to hoChild
                            
                            Send DoEnumChildren (iIndent+1) hoChild
                        Loop
                    End
                    
                    Case Begin
                        Case (iType=JTokenType_Object)
                            Send AppendTextLn to oResult ((Repeat("  ",iIndent))+"},")
                            Case Break
        
                        Case (iType=JTokenType_Array)
                            Send AppendTextLn to oResult ((Repeat("  ",iIndent))+"],")
                            Case Break

                            

                    Case End
                End_Procedure
            
                // fires when the button is clicked
                Procedure OnClick
                    String sJSON

                    // first we need to read the JSON object
                    Get Value of oJSONText to sJSON
                    
                    Integer hoJSON
                    Get DeserializeString of oParser sJSON to hoJSON
                    If (hoJSON=0) Begin
                        Send Info_Box "Deserialization failed"
                        Procedure_Return
                    End
                    
                    Set Value of oResult to ""
                    
                    Send DoEnumChildren 0 hoJSON           
                End_Procedure
            
            End_Object

            Object oResult is a cTextEdit
                Set Size to 142 237
                Set Location to 33 281
                Set Label to "after Deserialize / Enumerate"
            End_Object
        End_Object

        Object oDbTabPage4 is a dbTabPage
            Set Label to "Create"

            Object oTextBox1 is a TextBox
                Set Size to 10 204
                Set Location to 6 6
                Set Label to "The JSON library also allows you to create a JSON object"
            End_Object

            Object oButton3 is a Button
                Set Size to 14 73
                Set Location to 28 9
                Set Label to "Create Example"
            
                // fires when the button is clicked
                Procedure OnClick
                    Integer hoJSONObj
                    
                    // create a new empty JSON Object
                    Get NewJSONObject of oParser to hoJSONObj
                    
                    // add properties to our object 
                    // 
                    // properties have a name and value
                    //
                    // we use typed values such as 
                    //      string
                    //      integer
                    //      boolean
                    //      null
                    
                    Send AddString  to hoJSONObj    "Name"      "StarZen Technologies, Inc"
                    Send AddString  to hoJSONObj    "Street"   "3340 SE Federal HWY #269"            
                    Send AddString  to hoJSONObj    "City"      "Stuart"
                    Send AddInteger to hoJSONObj    "Zip"       34997
                    Send AddBoolean to hoJSONObj    "Business"  True
                    Send AddBoolean to hoJSONObj    "Home"      False
                    Send AddNull    to hoJSONObj    "ANullValue" 

                    // create another JSON object and add as a child object                    
                    Integer hoJSONObjChild
                    Get NewJSONObject of oParser to hoJSONObjChild
                    
                    Send AddString to hoJSONObjChild "Email"    "info@starzen.com"
                    Send AddString to hoJSONObjChild "Web"      "www.starzen.com"            
                    Send AddString to hoJSONObjChild "Phone"    "(561) 329-2598"            
                    
                    // add the object as a property called Contact Info
                    Send AddObject to hoJSONObj "Contact Info" hoJSONObjChild        
                    
                    // now lets create an array and add it to our JSON object as well
                    Integer hoJSONArr
                    Get NewJSONArray of oParser to hoJSONArr
                    
                    // add items to array - no property names here
                    Send AddString to hoJSONArr "" "3340 SE Federal HWY"
                    Send AddString to hoJSONArr "" "Suite 269"

                    // we can also add objects to an array        
                    Integer hoJSONObj2
                    Get NewJSONObject of oParser to hoJSONObj2
                    Send AddString to hoJSONObj2 "City" "Stuart"
                    Send AddString to hoJSONObj2 "State" "FL"            
                    Send AddInteger to hoJSONObj2 "Zip" "34997"            
                    
                    // add object to array - no property name
                    Send AddObject to hoJSONArr "" hoJSONObj2
                    
                    Send AddObject to hoJSONObj "Address" hoJSONArr
        
                    
                    String sJSON
                    Get Serialize of hoJSONObj to sJSON
                    
                    Set Value of oJSONText1 to sJSON
                End_Procedure
            
            End_Object

            Object oJSONText1 is a cTextEdit
                Set Size to 142 237
                Set Location to 55 281
                Set Label to "after Deserialize / Serialize"
            End_Object

            Object oButton3 is a Button
                Set Size to 14 73
                Set Location to 44 9
                Set Label to "Clone Example"
            
                // fires when the button is clicked
                Procedure OnClick
                    Integer hoJSONObj
                    
                    // create a new empty JSON Object
                    Get NewJSONObject of oParser to hoJSONObj
                    
                    // add properties to our object 
                    // 
                    // properties have a name and value
                    //
                    // we use typed values such as 
                    //      string
                    //      integer
                    //      boolean
                    //      null
                    
                    Send AddString  to hoJSONObj    "Name"      "StarZen Technologies, Inc"
                    Send AddString  to hoJSONObj    "Street"   "3340 SE Federal HWY #269"            
                    Send AddString  to hoJSONObj    "City"      "Stuart"
                    Send AddInteger to hoJSONObj    "Zip"       34997
                    Send AddBoolean to hoJSONObj    "Business"  True
                    Send AddBoolean to hoJSONObj    "Home"      False
                    Send AddNull    to hoJSONObj    "ANullValue" 

                    // create another JSON object and add as a child object                    
                    Integer hoJSONObjChild
                    Get NewJSONObject of oParser to hoJSONObjChild
                    
                    Send AddString to hoJSONObjChild "Email"    "info@starzen.com"
                    Send AddString to hoJSONObjChild "Web"      "www.starzen.com"            
                    Send AddString to hoJSONObjChild "Phone"    "(561) 329-2598"            
                    
                    // add the object as a property called Contact Info
                    Send AddObject to hoJSONObj "Contact Info" hoJSONObjChild        
                    
                    // now lets create an array and add it to our JSON object as well
                    Integer hoJSONArr
                    Get NewJSONArray of oParser to hoJSONArr
                    
                    // add items to array - no property names here
                    Send AddString to hoJSONArr "" "3340 SE Federal HWY"
                    Send AddString to hoJSONArr "" "Suite 269"

                    // we can also add objects to an array        
                    Integer hoJSONObj2
                    Get NewJSONObject of oParser to hoJSONObj2
                    Send AddString to hoJSONObj2 "City" "Stuart"
                    Send AddString to hoJSONObj2 "State" "FL"            
                    Send AddInteger to hoJSONObj2 "Zip" "34997"            
                    
                    // add object to array - no property name
                    Send AddObject to hoJSONArr "" hoJSONObj2
                    
                    Send AddObject to hoJSONObj "Address" hoJSONArr
                    
                    Integer hoCloned
                    Get DeepClone of hoJSONObjChild to hoCloned
                    Send AddObject to hoJSONObj "Cloned" hoCloned
                    
                    String sJSON
                    Get Serialize of hoJSONObj to sJSON
                    
                    Set Value of oJSONText1 to sJSON
                End_Procedure
            
            End_Object

            Object oButton3 is a Button
                Set Size to 14 73
                Set Location to 76 8
                Set Label to "Remove Child"
            
                // fires when the button is clicked
                Procedure OnClick
                    Integer hoJSONObj
                    
                    // create a new empty JSON Object
                    Get NewJSONObject of oParser to hoJSONObj
                    
                    // add properties to our object 
                    // 
                    // properties have a name and value
                    //
                    // we use typed values such as 
                    //      string
                    //      integer
                    //      boolean
                    //      null
                    
                    Send AddString  to hoJSONObj    "Name"      "StarZen Technologies, Inc"
                    Send AddString  to hoJSONObj    "Street"   "3340 SE Federal HWY #269"            
                    Send AddString  to hoJSONObj    "City"      "Stuart"
                    Send AddInteger to hoJSONObj    "Zip"       34997
                    Send AddBoolean to hoJSONObj    "Business"  True
                    Send AddBoolean to hoJSONObj    "Home"      False
                    Send AddNull    to hoJSONObj    "ANullValue" 

                    // create another JSON object and add as a child object                    
                    Integer hoJSONObjChild
                    Get NewJSONObject of oParser to hoJSONObjChild
                    
                    Send AddString to hoJSONObjChild "Email"    "info@starzen.com"
                    Send AddString to hoJSONObjChild "Web"      "www.starzen.com"            
                    Send AddString to hoJSONObjChild "Phone"    "(561) 329-2598"            
                    
                    // add the object as a property called Contact Info
                    Send AddObject to hoJSONObj "Contact Info" hoJSONObjChild        
                    
                    // now lets create an array and add it to our JSON object as well
                    Integer hoJSONArr
                    Get NewJSONArray of oParser to hoJSONArr
                    
                    // add items to array - no property names here
                    Send AddString to hoJSONArr "" "3340 SE Federal HWY"
                    Send AddString to hoJSONArr "" "Suite 269"

                    // we can also add objects to an array        
                    Integer hoJSONObj2
                    Get NewJSONObject of oParser to hoJSONObj2
                    Send AddString to hoJSONObj2 "City" "Stuart"
                    Send AddString to hoJSONObj2 "State" "FL"            
                    Send AddInteger to hoJSONObj2 "Zip" "34997"            
                    
                    // add object to array - no property name
                    Send AddObject to hoJSONArr "" hoJSONObj2
                    
                    Send AddObject to hoJSONObj "Address" hoJSONArr
                    
                    Integer hoCloned
                    Get DeepClone of hoJSONObjChild to hoCloned
                    Send AddObject to hoJSONObj "Cloned" hoCloned
                    
                    Send RemoveChild to hoJSONObj "Name"
                    Send RemoveChild to hoJSONObj "Contact Info"
                    
                    String sJSON
                    Get Serialize of hoJSONObj to sJSON
                    
                    Set Value of oJSONText1 to sJSON
                End_Procedure
            
            End_Object

            Object oButton3 is a Button
                Set Size to 14 73
                Set Location to 93 8
                Set Label to "Remove All Children"
            
                // fires when the button is clicked
                Procedure OnClick
                    Integer hoJSONObj
                    
                    // create a new empty JSON Object
                    Get NewJSONObject of oParser to hoJSONObj
                    
                    // add properties to our object 
                    // 
                    // properties have a name and value
                    //
                    // we use typed values such as 
                    //      string
                    //      integer
                    //      boolean
                    //      null
                    
                    Send AddString  to hoJSONObj    "Name"      "StarZen Technologies, Inc"
                    Send AddString  to hoJSONObj    "Street"   "3340 SE Federal HWY #269"            
                    Send AddString  to hoJSONObj    "City"      "Stuart"
                    Send AddInteger to hoJSONObj    "Zip"       34997
                    Send AddBoolean to hoJSONObj    "Business"  True
                    Send AddBoolean to hoJSONObj    "Home"      False
                    Send AddNull    to hoJSONObj    "ANullValue" 

                    // create another JSON object and add as a child object                    
                    Integer hoJSONObjChild
                    Get NewJSONObject of oParser to hoJSONObjChild
                    
                    Send AddString to hoJSONObjChild "Email"    "info@starzen.com"
                    Send AddString to hoJSONObjChild "Web"      "www.starzen.com"            
                    Send AddString to hoJSONObjChild "Phone"    "(561) 329-2598"            
                    
                    // add the object as a property called Contact Info
                    Send AddObject to hoJSONObj "Contact Info" hoJSONObjChild        
                    
                    // now lets create an array and add it to our JSON object as well
                    Integer hoJSONArr
                    Get NewJSONArray of oParser to hoJSONArr
                    
                    // add items to array - no property names here
                    Send AddString to hoJSONArr "" "3340 SE Federal HWY"
                    Send AddString to hoJSONArr "" "Suite 269"

                    // we can also add objects to an array        
                    Integer hoJSONObj2
                    Get NewJSONObject of oParser to hoJSONObj2
                    Send AddString to hoJSONObj2 "City" "Stuart"
                    Send AddString to hoJSONObj2 "State" "FL"            
                    Send AddInteger to hoJSONObj2 "Zip" "34997"            
                    
                    // add object to array - no property name
                    Send AddObject to hoJSONArr "" hoJSONObj2
                    
                    Send AddObject to hoJSONObj "Address" hoJSONArr
                    
                    Integer hoCloned
                    Get DeepClone of hoJSONObjChild to hoCloned
                    Send AddObject to hoJSONObj "Cloned" hoCloned
                    
                    Send RemoveAllChildren to hoJSONObj 
                    
                    String sJSON
                    Get Serialize of hoJSONObj to sJSON
                    
                    Set Value of oJSONText1 to sJSON
                End_Procedure
            
            End_Object
        End_Object

        Object oDbTabPage6 is a dbTabPage
            Set Label to "XML"

            Object oJSONTextForXML is a cTextEdit
                Set Size to 142 237
                Set Location to 16 282
                Set Label to "JSON Text"
            End_Object
            
            Object oXMLTextForJSON is a cTextEdit
                Set Size to 142 237
                Set Location to 17 9
                Set Label to "XML"
            End_Object

            Object oButton1 is a Button
                Set Size to 14 45
                Set Location to 165 382
                Set Label to "To XML"
            
                // fires when the button is clicked
                Procedure OnClick
                    String sJSON
                    Get Value of oJSONTextForXML to sJSON
                    
                    String sXML
                    Get JSONToXML of oParser sJSON to sXML
                    Set Value of oXMLTextForJSON to sXML
                End_Procedure
            
            End_Object

            Object oButton1 is a Button
                Set Size to 14 45
                Set Location to 165 101
                Set Label to "To JSON"
            
                // fires when the button is clicked
                Procedure OnClick
                    String sXML
                    Get Value of oXMLTextForJSON to sXML
                    
                    String sJSON
                    Get XMLToJSON of oParser sXML to sJSON
                    Set Value of oJSONTextForXML to sJSON
                End_Procedure
            
            End_Object
        End_Object
    
    End_Object

    
    Procedure Popup
        Forward Send Popup
        
        String sFilePath
        Get_File_Path "jsonsample1.txt" to sFilePath
        If (trim(sFilePath)<>"") Begin
            Send Read to oJSONText sFilePath
            Send Read to oPathJSONText sFilePath
            Send Read to oEnumJSONText sFilePath
        End

        Get_File_Path "jsonsample2.txt" to sFilePath
        If (trim(sFilePath)<>"") Begin
            Send Read to oJPathJSONText sFilePath
        End

        Get_File_Path "xmlsample.txt" to sFilePath
        If (trim(sFilePath)<>"") Begin
            Send Read to oXMLTextForJSON sFilePath
        End        
                
        Send CreateComObject to oParser
        If (IsNullComObject(pvComObject(oParser(Self)))) Begin
            Error 255 "Unable to create Parser"
        End
    End_Procedure    
Cd_End_Object
