Use Windows.pkg
Use DFClient.pkg
Use cszJSONParser.pkg

Deferred_View Activate_oTestJSONParser for ;
Object oTestJSONParser is a dbView

    Object oParser is a cszJSONParser
    End_Object
    
    Set Border_Style to Border_Thick
    Set Size to 200 300
    Set Location to 2 2
    Set Label to "TestJSONParser"

    Object oButton1 is a Button
        Set Location to 24 40
        Set Label to 'test'
        
        // fires when the button is clicked
        Procedure DoEnumChildren Integer iIndent Variant vObj
            String sName sType
            Integer iType
            
            Get ComGetTokenType of oParser vObj to iType
            Get ComGetTokenTypeAsString of oParser vObj to sType
            
            String sPath
            Get ComGetTokenPath of oParser vObj to sPath
            
            Boolean bHasValues
            Get ComGetHasValues of oParser vObj to bHasValues
            
            Case Begin
                Case (iType=JTokenType_Object)
                    Showln (Repeat("  ",iIndent)) "{"
                    Case Break

                Case (iType=JTokenType_Property)
                    Get ComGetPropertyName of oParser vObj to sName
                    Showln (Repeat("  ",iIndent)) sName
                    Case Break
                    
                Case (iType=JTokenType_Array)
                    Showln (Repeat("  ",iIndent)) "["
                    Case Break
                                    
                Case Else
                    String sVal
                    Get ComGetTokenValueAsString of oParser vObj to sVal
                    Showln (Repeat("  ",iIndent)) bHasValues "-" sType "=" sVal
                    Case Break
            Case End
            
            If (bHasValues) Begin
                Integer iCount
                Get ComGetTokenChildCount of oParser vObj to iCount
                Integer iIndex
                For iIndex from 0 to (icount-1)                
                    Variant vChild
                    Get ComGetChild of oParser vObj iIndex to vChild
                    
                    Send DoEnumChildren (iIndent+1) vChild
                Loop
            End
            
            Case Begin
                Case (iType=JTokenType_Object)
                    Showln (Repeat("  ",iIndent)) "}"
                    Case Break

                Case (iType=JTokenType_Array)
                    Showln (Repeat("  ",iIndent)) "]"
                    Case Break
            Case End
        End_Procedure
        
        Procedure OnClick
            
            String sJson
            Move '{    "glossary": {        "title": "example glossary",		"GlossDiv": {            "title": "S",			"GlossList": {                "GlossEntry": {                    "ID": "SGML",					"SortAs": "SGML",					"GlossTerm": "Standard Generalized Markup Language",					"Acronym": "SGML",' to sJson
            Append sJson '					"Abbrev": "ISO 8879:1986",					"GlossDef": {                        "para": "A meta-markup language, used to create markup languages such as DocBook.",						"GlossSeeAlso": ["GML", "XML"]                    },					"GlossSee": "markup"                }            }        }    }}'
            
            Variant vjsonobj 
            Get ComDeserializeString of oParser sJson to vjsonobj
            
            
            Variant vToken
            Get ComGetAtPath of oParser vjsonobj "1212" to vToken
            If (IsNullComObject(vToken)) Begin
                Showln "not found"
            End

            String sVal

            
            Get ComGetAtPath of oParser vjsonobj "glossary" to vToken
            If (not(IsNullComObject(vToken))) Begin
                Get ComGetValue of oParser vToken "title" to sVal                
            End

            String sJSONText
            Get  ComSerialize of oParser vToken to sJSONText
                        
            Get ComGetAtPath of oParser vjsonobj "glossary.title" to vToken
            If (not(IsNullComObject(vToken))) Begin
                Get ComGetTokenValueAsString of oParser vToken to sVal
            End

            Get ComGetAtPath of oParser vjsonobj "glossary.GlossDiv.GlossList.GlossEntry.GlossDef.GlossSeeAlso[0]" to vToken
            If (not(IsNullComObject(vToken))) Begin
                Get ComGetTokenValueAsString of oParser vToken to sVal
            End
            
            Send DoEnumChildren 0 vjsonobj
        End_Procedure
    
    End_Object

    Object oButton2 is a Button
        Set Location to 100 40
        Set Label to 'oButton2'
    
        // fires when the button is clicked
        Procedure OnClick

            String sJson
            Move '{    "glossary": {        "title": "example glossary",		"GlossDiv": {            "title": "S",			"GlossList": {                "GlossEntry": {                    "ID": "SGML",					"SortAs": "SGML",					"GlossTerm": "Standard Generalized Markup Language",					"Acronym": "SGML",' to sJson
            Append sJson '					"Abbrev": "ISO 8879:1986",					"GlossDef": {                        "para": "A meta-markup language, used to create markup languages such as DocBook.",						"GlossSeeAlso": ["GML", "XML"]                    },					"GlossSee": "markup"                }            }        }    }}'

            Integer hoJSON 
            // returns JSON Object
            Get DeserializeString of oParser sJson to hoJSON    
            
            String sJSONtext
            Get Serialize of hoJSON to sJSONtext
            
            String sType
            String sVal
            // returns type of JSON object
            // object, property, string, array, etc
            Get TokenTypeAsString of hoJSON to sType
            
            Integer hoGlossary 
            // find a child token by name
            Get ChildTokenByName of hoJSON "glossary" to hoGlossary
                        
            Integer iCount
            // get the number of child tokens
            Get ChildCount of hoGlossary to iCount

            Integer hoFirst
            // get a child token by index
            Get ChildTokenByIndex of hoGlossary 0 to hoFirst

            Get Serialize of hoFirst to sJSONtext

            Get TokenTypeAsString of hoFirst to sType
            String sPropName
            Get PropertyName of hoFirst to sPropName                        
            
            Integer hoGlossaryTitle 
            Get ChildTokenByName of hoGlossary "title" to hoGlossaryTitle
            
            // get the value of a token 
            Get TokenValue of hoGlossaryTitle to sVal
            
            // get the value of a child token
            Get ChildValueByName of hoGlossary "title" to sVal
            
            String sPath
            // get the path of a token
            Get TokenPath of hoGlossaryTitle to sPath
            
            Integer hoToken        
            // get the token by path
            Get GetAtPath of hoJSON "glossary.GlossDiv.GlossList.GlossEntry.GlossDef.GlossSeeAlso[0]" to hoToken
            If (hoToken) Begin                
                Get TokenValue of hoToken to sVal 
            End
            
            Get GetValueAtPath of hoJSON "glossary.GlossDiv.GlossList.GlossEntry.GlossDef.GlossSeeAlso[0]" to sVal
            
            Get GetAtPath of hoJSON "glossary.GlossDiv.GlossList.GlossEntry.GlossDef.GlossSeeAlso" to hoToken
            If (hoToken) Begin                
                Get TokenTypeAsString of hoToken to sType                
                Get ChildCount of hoToken to iCount
                Get ChildValueByIndex of hoToken 1 to sVal
            End
        End_Procedure
    
    End_Object

    Object oButton3 is a Button
        Set Location to 145 38
        Set Label to 'oButton3'
    
        // fires when the button is clicked
        Procedure OnClick

            Variant vJSONObj vJSONArr
            Get ComNewJSONObject of oParser to vJSONObj
            Get ComNewJSONArray of oParser to vJSONArr
            
            String sType
            Get ComGetTokenTypeAsString of oParser vJSONObj to sType
            Get ComGetTokenTypeAsString of oParser vJSONArr to sType
            
            Send ComAddString to oParser vJSONObj "MYProp" "MyVal"
            Send ComAddString to oParser vJSONArr "" "MyVal"
        End_Procedure
    
    End_Object

    Object oButton4 is a Button
        Set Location to 168 38
        Set Label to 'oButton4'
    
        // fires when the button is clicked
        Procedure OnClick   
            For WindowIndex from 1 to 100         
                Send TestCreate
            Loop
        End_Procedure

        Procedure TestCreate
            
            Integer hoJSONObj
            Get NewJSONObject of oParser to hoJSONObj
            // add items to object - property name and value
            Send AddString to hoJSONObj "Name" "Mike"
            Send AddString to hoJSONObj "Street" "4765 SE Chiles CT"            
            Send AddInteger to hoJSONObj "Zip" 34997
            Send AddBoolean to hoJSONObj "Home" True
            Send AddNull to hoJSONObj "IsNull" 
            
            Integer hoJSONObj1
            Get NewJSONObject of oParser to hoJSONObj1
            Send AddString to hoJSONObj1 "Page" "1"
            Send AddString to hoJSONObj1 "Content" "Bla"            
            
            Send AddObject to hoJSONObj "Hello" hoJSONObj1

            
            Integer hoJSONArr
            Get NewJSONArray of oParser to hoJSONArr
            // add items to array - no property names here
            Send AddString to hoJSONArr "" "4765 SE CHiles CT"
            Send AddString to hoJSONArr "" "Stuart"
            Send AddString to hoJSONArr "" "FL"

            Integer hoJSONObj2
            Get NewJSONObject of oParser to hoJSONObj2
            Send AddString to hoJSONObj2 "Cat" "ChiChi"
            Send AddString to hoJSONObj2 "Dog" "Dixie"            
            
            // add object to array - no propery name
            Send AddObject to hoJSONArr "" hoJSONObj2
            
            Send AddObject to hoJSONObj "fooy" hoJSONArr

            
            String sJSON
            Get Serialize of hoJSONObj to sJSON
        
            Send Destroy to hoJSONObj1
            Send Destroy to hoJSONObj2
            Send Destroy to hoJSONArr                       
            Send Destroy to hoJSONObj                        
        End_Procedure                
    End_Object

    Object oButton5 is a Button
        Set Location to 136 189
        Set Label to 'oButton5'
    
        // fires when the button is clicked
        Procedure OnClick
            Integer hoJSONObj
            Get NewJSONObject of oParser to hoJSONObj

            Send AddString to hoJSONObj "Name" "Mike"
            Send AddString to hoJSONObj "Name" "4765 SE Chiles CT"            
        End_Procedure
    
    End_Object

    Object oButton6 is a Button
        Set Location to 166 134
        Set Label to 'oButton6'
    
        // fires when the button is clicked
        Procedure OnClick
            Integer hoJSONObj
            Get NewJSONObject of oParser to hoJSONObj

            Send AddString to hoJSONObj "Name" "Mike"
            Send AddString to hoJSONObj "Name1" "4765 SE Chiles CT"            
            Send AddString to hoJSONObj "Name2" "4765 SE Chiles CT"            
            
            Integer[] objs
            
            Get SelectTokens of hoJSONObj "$.*" to objs
        End_Procedure
    
    End_Object

    Procedure Popup
        Forward Send Popup
        
        Send CreateComObject to oParser            
        
    End_Procedure
Cd_End_Object
